// Code generated by mockery v2.42.3. DO NOT EDIT.

package services

import (
	mock "github.com/stretchr/testify/mock"
	address "gitlab.com/accumulatenetwork/accumulate/pkg/types/address"
	url "gitlab.com/accumulatenetwork/accumulate/pkg/url"
	protocol "gitlab.com/accumulatenetwork/accumulate/protocol"
	api "gitlab.com/accumulatenetwork/core/wallet/cmd/accumulate/walletd/api"
	bip44 "gitlab.com/accumulatenetwork/core/wallet/cmd/accumulate/walletd/bip44"
)

// MockLedgerManager is an autogenerated mock type for the LedgerManager type
type MockLedgerManager struct {
	mock.Mock
}

type MockLedgerManager_Expecter struct {
	mock *mock.Mock
}

func (_m *MockLedgerManager) EXPECT() *MockLedgerManager_Expecter {
	return &MockLedgerManager_Expecter{mock: &_m.Mock}
}

// Derive provides a mock function with given fields: id, path, pin, display, labels
func (_m *MockLedgerManager) Derive(id *url.URL, path bip44.Derivation, pin bool, display bool, labels ...string) (address.Address, error) {
	_va := make([]interface{}, len(labels))
	for _i := range labels {
		_va[_i] = labels[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, id, path, pin, display)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for Derive")
	}

	var r0 address.Address
	var r1 error
	if rf, ok := ret.Get(0).(func(*url.URL, bip44.Derivation, bool, bool, ...string) (address.Address, error)); ok {
		return rf(id, path, pin, display, labels...)
	}
	if rf, ok := ret.Get(0).(func(*url.URL, bip44.Derivation, bool, bool, ...string) address.Address); ok {
		r0 = rf(id, path, pin, display, labels...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(address.Address)
		}
	}

	if rf, ok := ret.Get(1).(func(*url.URL, bip44.Derivation, bool, bool, ...string) error); ok {
		r1 = rf(id, path, pin, display, labels...)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockLedgerManager_Derive_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Derive'
type MockLedgerManager_Derive_Call struct {
	*mock.Call
}

// Derive is a helper method to define mock.On call
//   - id *url.URL
//   - path bip44.Derivation
//   - pin bool
//   - display bool
//   - labels ...string
func (_e *MockLedgerManager_Expecter) Derive(id interface{}, path interface{}, pin interface{}, display interface{}, labels ...interface{}) *MockLedgerManager_Derive_Call {
	return &MockLedgerManager_Derive_Call{Call: _e.mock.On("Derive",
		append([]interface{}{id, path, pin, display}, labels...)...)}
}

func (_c *MockLedgerManager_Derive_Call) Run(run func(id *url.URL, path bip44.Derivation, pin bool, display bool, labels ...string)) *MockLedgerManager_Derive_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]string, len(args)-4)
		for i, a := range args[4:] {
			if a != nil {
				variadicArgs[i] = a.(string)
			}
		}
		run(args[0].(*url.URL), args[1].(bip44.Derivation), args[2].(bool), args[3].(bool), variadicArgs...)
	})
	return _c
}

func (_c *MockLedgerManager_Derive_Call) Return(_a0 address.Address, _a1 error) *MockLedgerManager_Derive_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockLedgerManager_Derive_Call) RunAndReturn(run func(*url.URL, bip44.Derivation, bool, bool, ...string) (address.Address, error)) *MockLedgerManager_Derive_Call {
	_c.Call.Return(run)
	return _c
}

// Sign provides a mock function with given fields: id, path, txn, sig
func (_m *MockLedgerManager) Sign(id *url.URL, path bip44.Derivation, txn *protocol.Transaction, sig protocol.Signature) (protocol.Signature, error) {
	ret := _m.Called(id, path, txn, sig)

	if len(ret) == 0 {
		panic("no return value specified for Sign")
	}

	var r0 protocol.Signature
	var r1 error
	if rf, ok := ret.Get(0).(func(*url.URL, bip44.Derivation, *protocol.Transaction, protocol.Signature) (protocol.Signature, error)); ok {
		return rf(id, path, txn, sig)
	}
	if rf, ok := ret.Get(0).(func(*url.URL, bip44.Derivation, *protocol.Transaction, protocol.Signature) protocol.Signature); ok {
		r0 = rf(id, path, txn, sig)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(protocol.Signature)
		}
	}

	if rf, ok := ret.Get(1).(func(*url.URL, bip44.Derivation, *protocol.Transaction, protocol.Signature) error); ok {
		r1 = rf(id, path, txn, sig)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockLedgerManager_Sign_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Sign'
type MockLedgerManager_Sign_Call struct {
	*mock.Call
}

// Sign is a helper method to define mock.On call
//   - id *url.URL
//   - path bip44.Derivation
//   - txn *protocol.Transaction
//   - sig protocol.Signature
func (_e *MockLedgerManager_Expecter) Sign(id interface{}, path interface{}, txn interface{}, sig interface{}) *MockLedgerManager_Sign_Call {
	return &MockLedgerManager_Sign_Call{Call: _e.mock.On("Sign", id, path, txn, sig)}
}

func (_c *MockLedgerManager_Sign_Call) Run(run func(id *url.URL, path bip44.Derivation, txn *protocol.Transaction, sig protocol.Signature)) *MockLedgerManager_Sign_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(*url.URL), args[1].(bip44.Derivation), args[2].(*protocol.Transaction), args[3].(protocol.Signature))
	})
	return _c
}

func (_c *MockLedgerManager_Sign_Call) Return(_a0 protocol.Signature, _a1 error) *MockLedgerManager_Sign_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockLedgerManager_Sign_Call) RunAndReturn(run func(*url.URL, bip44.Derivation, *protocol.Transaction, protocol.Signature) (protocol.Signature, error)) *MockLedgerManager_Sign_Call {
	_c.Call.Return(run)
	return _c
}

// Wallets provides a mock function with given fields:
func (_m *MockLedgerManager) Wallets() ([]*api.LedgerWalletInfo, error) {
	ret := _m.Called()

	if len(ret) == 0 {
		panic("no return value specified for Wallets")
	}

	var r0 []*api.LedgerWalletInfo
	var r1 error
	if rf, ok := ret.Get(0).(func() ([]*api.LedgerWalletInfo, error)); ok {
		return rf()
	}
	if rf, ok := ret.Get(0).(func() []*api.LedgerWalletInfo); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*api.LedgerWalletInfo)
		}
	}

	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockLedgerManager_Wallets_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Wallets'
type MockLedgerManager_Wallets_Call struct {
	*mock.Call
}

// Wallets is a helper method to define mock.On call
func (_e *MockLedgerManager_Expecter) Wallets() *MockLedgerManager_Wallets_Call {
	return &MockLedgerManager_Wallets_Call{Call: _e.mock.On("Wallets")}
}

func (_c *MockLedgerManager_Wallets_Call) Run(run func()) *MockLedgerManager_Wallets_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run()
	})
	return _c
}

func (_c *MockLedgerManager_Wallets_Call) Return(_a0 []*api.LedgerWalletInfo, _a1 error) *MockLedgerManager_Wallets_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockLedgerManager_Wallets_Call) RunAndReturn(run func() ([]*api.LedgerWalletInfo, error)) *MockLedgerManager_Wallets_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockLedgerManager creates a new instance of MockLedgerManager. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockLedgerManager(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockLedgerManager {
	mock := &MockLedgerManager{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
